//+------------------------------------------------------------------+ 
//|   _TRO_IND2                                                      | 
//|                                                                  | 
//|   Copyright  2008, Avery T. Horton, Jr. aka TheRumpledOne       |
//|                                                                  |
//|   PO BOX 43575, TUCSON, AZ 85733                                 |
//|                                                                  |
//|   GIFTS AND DONATIONS ACCEPTED                                   | 
//|                                                                  |
//|   therumpledone@gmail.com                                        |  
//+------------------------------------------------------------------+ 

#property  copyright "Copyright  2008, Avery T. Horton, Jr. aka TRO" 
#property  link      "http://www.therumpledone.com/" 

//---- indicator settings
#property  indicator_chart_window
#property  indicator_buffers 2
#property indicator_color1 Red      
#property indicator_color2 Lime


extern int myPeriod = 5;
extern int myPlotBars = 1500;
extern int myLineType = 1 ;
extern int myLineWidth = 3 ;

//---- buffers
double ExtMapBuffer1[];
double ExtMapBuffer2[];



int Draw4HowLong,shift,i,loopbegin,width,length,c;

double sum[];
double lengthvar;
double tmp ;
double wt[];


//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- 2 additional buffers are used for counting.
   IndicatorBuffers(4);
   
//---- drawing settings
   SetIndexBuffer(0,ExtMapBuffer1);
   SetIndexBuffer(1,ExtMapBuffer2);
   SetIndexBuffer(2,sum);
   SetIndexBuffer(3,wt);
   
   SetIndexStyle(0,myLineType,0,myLineWidth);
   SetIndexStyle(1,myLineType,0,myLineWidth);


//---- initialization done
   return(0);
  }

int start()

  {   Draw4HowLong = Bars-myPeriod - 5;
      length = myPeriod;
      loopbegin = Draw4HowLong - length - 1;
 
    double pr=2.0/(length+1);
    
      for(shift = loopbegin; shift >= 0; shift--)
      { 

      if(shift==Bars-2) { wt[shift+1]=Close[shift+1];  }
      
      wt[shift]=Close[shift]*pr+wt[shift+1]*(1-pr);
 
         
         
//========== COLOR CODING ===========================================               
        
       ExtMapBuffer1[shift] = wt[shift]; 
       ExtMapBuffer2[shift] = wt[shift]; 
       
        if (wt[shift] > wt[shift+1])
        {
        ExtMapBuffer1[shift] = EMPTY_VALUE;
        ExtMapBuffer2[shift+1] = wt[shift+1];
        
        }
       else if (wt[shift] < wt[shift+1]) 
        {
        ExtMapBuffer2[shift] = EMPTY_VALUE; 
        ExtMapBuffer1[shift+1] = wt[shift+1];
        }

      }
    
      return(0);
  }
//+------------------------------------------------------------------+



