//+------------------------------------------------------------------+
//| mtf Price bars(candles)                          Heiken Ashi.mq4 |
//|                      Copyright  2004, MetaQuotes Software Corp. |
//| (MTF ForexTSD.com 2007mladen)          http://www.metaquotes.net |
//+------------------------------------------------------------------+
//| For Heiken Ashi we recommend next chart settings ( press F8 or   |
//| select on menu 'Charts'->'Properties...'):                       |
//|  - On 'Color' Tab select 'Black' for 'Line Graph'                |
//|  - On 'Common' Tab disable 'Chart on Foreground' checkbox and    |
//|    select 'Line Chart' radiobutton                               |
//+------------------------------------------------------------------+
#property copyright "Copyright  2004, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net"

#property indicator_chart_window
#property indicator_buffers 4
#property indicator_color1 Maroon     //HL_O>C
#property indicator_color2 RoyalBlue  //HL_O<C
#property indicator_color3 Maroon     //O<C
#property indicator_color4 RoyalBlue  //O>C
#property indicator_width1 2
#property indicator_width2 2
#property indicator_width3 6
#property indicator_width4 6

//---- buffers
double ExtMapBuffer1[]; //HL_O>C
double ExtMapBuffer2[]; //HL_O<C
double ExtMapBuffer3[]; //O<C
double ExtMapBuffer4[]; //O>C
//----
int ExtCountedBars=0;

extern int Shift=0;
extern int ajstmShift=0;
extern string     ____ = "_____";
extern int timeFrame = 0;
extern string note_timeFrames = "M1;5,15,30,60H1;240H4;1440D1;10080W1;43200MN";
extern string     _____ = "_____";
extern string  IndicatorExactName = "Price_mtf";
extern string  note___Ind_Name = "if ind.Name changed - enter New Name";


//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//|------------------------------------------------------------------|
int init()
  {
//---- indicators
   SetIndexStyle(0,DRAW_HISTOGRAM); //LH
   SetIndexBuffer(0, ExtMapBuffer1);
   SetIndexStyle(1,DRAW_HISTOGRAM);
   SetIndexBuffer(1, ExtMapBuffer2);//HL
   SetIndexStyle(2,DRAW_HISTOGRAM);
   SetIndexBuffer(2, ExtMapBuffer3);//O
   SetIndexStyle(3,DRAW_HISTOGRAM);
   SetIndexBuffer(3, ExtMapBuffer4);//C
//----      
    if(timeFrame==0) timeFrame = Period();
  SetIndexShift(0, ajstmShift+Shift*timeFrame/Period());
  SetIndexShift(1, ajstmShift+Shift*timeFrame/Period());
  SetIndexShift(2, ajstmShift+Shift*timeFrame/Period());
  SetIndexShift(3, ajstmShift+Shift*timeFrame/Period());

//
   SetIndexDrawBegin(0,5);

    IndicatorShortName("Price ["+timeFrame+"] ");  
//----
    if (timeFrame < Period()) timeFrame = Period();





//---- initialization done
   return(0);
  }
//+------------------------------------------------------------------+
//| Custor indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//---- TODO: add your code here
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   double haOpen, haHigh, haLow, haClose;
 //
   int counted_bars1=IndicatorCounted();
   int      limit1,i1;


   if(counted_bars1 < 0) return(-1);
   limit1 = Bars-counted_bars1;

   //
   //
   //    MTF mode operating (mladen)
   //
   //

   if (timeFrame != Period())
      {
         limit1 = MathMax(limit1,timeFrame/Period());
         datetime TimeArray[];
            ArrayCopySeries(TimeArray ,MODE_TIME ,NULL,timeFrame);
         
            //
            //
            //
            //
            //
         
            for(i1=0,int y=0; i1<limit1; i1++)
            {
               if(Time[i1]<TimeArray[y]) y++;
                     ExtMapBuffer1[i1]  = iCustom(NULL,timeFrame,IndicatorExactName,0,y);
                     ExtMapBuffer2[i1]  = iCustom(NULL,timeFrame,IndicatorExactName,1,y);
                     ExtMapBuffer3[i1]  = iCustom(NULL,timeFrame,IndicatorExactName,2,y);
                     ExtMapBuffer4[i1]  = iCustom(NULL,timeFrame,IndicatorExactName,3,y);
      
            }
         return(0);         
      }
      
   //
   //
   //
   //
   //

  
//--  
   if(Bars<=10) return(0);
   ExtCountedBars=IndicatorCounted();
//---- check for possible errors
   if (ExtCountedBars<0) return(-1);
//---- last counted bar will be recounted
   if (ExtCountedBars>0) ExtCountedBars--;
   int pos=Bars-ExtCountedBars-1;
   while(pos>=0)
     {
      haOpen=Open[pos];
      haClose=Close[pos];
      haHigh=High[pos];
      haLow=Low[pos];
      if (haOpen<haClose) 
        {
         ExtMapBuffer1[pos]=haLow;
         ExtMapBuffer2[pos]=haHigh;
        } 
      else
        {
         ExtMapBuffer1[pos]=haHigh;
         ExtMapBuffer2[pos]=haLow;
        } 
      ExtMapBuffer3[pos]=haOpen;
      ExtMapBuffer4[pos]=haClose;
 	   pos--;
     }
//----
   return(0);
  }
//+------------------------------------------------------------------+