
//----
#property indicator_chart_window
#property indicator_buffers 0

  extern string note1      = "Display the price in what corner?";
  extern string note2      = "Upper left=0; Upper right=1";
  extern string note3      = "Lower left=2; Lower right=3";
  extern int    WhatCorner = 1 ;
  extern int    myPeriod   = 13 ;

//----
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
  

   return(0);
  }
//+------------------------------------------------------------------+
//| Custor indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
   ObjectDelete("DBuyers");
   ObjectDelete("DSellers");
  
   Comment("");
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {


double bullp   = (iBullsPower(NULL, 0, myPeriod, PRICE_CLOSE,0));
double bearp   = (iBearsPower(NULL, 0, myPeriod, PRICE_CLOSE,0));

double vol     = iVolume(Symbol(),0,0);
double x       = bullp + bearp ;
double Buyers  = (bullp * vol) / x ;
double Sellers = (bearp * vol) / x ;

 
 
SetLabel("DBuyers" ,"Buyers = "+DoubleToStr(Buyers,0),1,30,"Simplified Arabic Fixed",20,0,Lime);
SetLabel("DSellers","Sellers = "+DoubleToStr(Sellers,0),1,92,"Simplified Arabic Fixed",20,0,Red);
     
  
    
//----
   return(0);
  }
 
void SetLabel(string name,string txt,int x,int y,string font,int size,int angle,color clr)
  {
   int idx=0;
   if(ObjectFind(name) == -1)
     {
       ObjectCreate(name, OBJ_LABEL, idx, 0, 0);
       ObjectSetText(name, txt, size, font, clr);
       ObjectSet(name, OBJPROP_XDISTANCE, x);
       ObjectSet(name, OBJPROP_YDISTANCE, y);
       ObjectSet(name, OBJPROP_CORNER, WhatCorner);
       ObjectSet(name, OBJPROP_ANGLE, angle);
     }
   else
     {
       ObjectSet(name, OBJPROP_XDISTANCE, x);
       ObjectSet(name, OBJPROP_YDISTANCE, y);
       ObjectSetText(name, txt, size, font, clr);
       ObjectSet(name, OBJPROP_CORNER, WhatCorner);
       ObjectSet(name, OBJPROP_ANGLE, angle);
     } 
  }
  
//+------------------------------------------------------------------+