//+------------------------------------------------------------------+ 
//|   _TRO_IND2                                                      | 
//|                                                                  | 
//|   Copyright  2008, Avery T. Horton, Jr. aka TheRumpledOne       |
//|                                                                  |
//|   PO BOX 43575, TUCSON, AZ 85733                                 |
//|                                                                  |
//|   GIFTS AND DONATIONS ACCEPTED                                   | 
//|                                                                  |
//|   therumpledone@gmail.com                                        |  
//+------------------------------------------------------------------+ 

//---- indicator settings
#property  indicator_chart_window
#property  indicator_buffers 2
#property indicator_color1 Red      
#property indicator_color2 Green


//---- buffers
double ExtMapBuffer1[];
double ExtMapBuffer2[];
extern int Rperiod = 5;
extern int Draw4HowLongg = 1500;
extern int Type = 3; 
int Draw4HowLong,shift,i,loopbegin,width,length,c;
double sum[];
double lengthvar;
double tmp ;
double wt[];


//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- 2 additional buffers are used for counting.
   IndicatorBuffers(4);
   
//---- drawing settings
   SetIndexBuffer(0,ExtMapBuffer1);
   SetIndexBuffer(1,ExtMapBuffer2);
   SetIndexBuffer(2,sum);
   SetIndexBuffer(3,wt);
   
   SetIndexStyle(0,DRAW_LINE,0,3);
   SetIndexStyle(1,DRAW_LINE,0,3);

/*

void SetIndexStyle(  	int index, int type, int style=EMPTY, int width=EMPTY, color clr=CLR_NONE)
Sets the new type, style, width and color for a given indicator line.
Parameters:
index 	  -   	Line index. Must lie between 0 and 7.
type 	  -   	Shape style. Can be one of Drawing shape styles listed.
style 	  -   	Drawing style. It is used for one-pixel thick lines. It can be one of the Drawing shape styles listed. EMPTY value means that the style will not be changed.
width 	  -   	Line width. Valid values are: 1,2,3,4,5. EMPTY value means that width will not be changed.
clr 	  -   	Line color. Absence of this parameter means that the color will not be changed.
*/
//---- initialization done
   return(0);
  }

int start()

  {   Draw4HowLong = Bars-Rperiod - 5;
      length = Rperiod;
      loopbegin = Draw4HowLong - length - 1;
 
    double pr=2.0/(length+1);
    
      for(shift = loopbegin; shift >= 0; shift--)
      { 

      if(shift==Bars-2) { wt[shift+1]=Close[shift+1];  }
      
      wt[shift]=Close[shift]*pr+wt[shift+1]*(1-pr);
 
         
         
//========== COLOR CODING ===========================================               
        
       ExtMapBuffer1[shift] = wt[shift]; 
       ExtMapBuffer2[shift] = wt[shift]; 
       
        if (wt[shift] > wt[shift+1])
        {
        ExtMapBuffer1[shift] = EMPTY_VALUE;
        ExtMapBuffer2[shift+1] = wt[shift+1];
        
        }
       else if (wt[shift] < wt[shift+1]) 
        {
        ExtMapBuffer2[shift] = EMPTY_VALUE; 
        ExtMapBuffer1[shift+1] = wt[shift+1];
        }

      }
    
      return(0);
  }
//+------------------------------------------------------------------+



