//+------------------------------------------------------------------+
//|                _TRO_HL_LINE                                   |
//|                                                                  |
//|                                                                  |
//+------------------------------------------------------------------+

#property indicator_chart_window 

#property indicator_buffers 2

#property indicator_color1 Lime 
#property indicator_color2 Red
 

// indicators parameters


extern int myPeriod=5; 

//---- buffers
double P1Buffer[];
double P2Buffer[];
 

int myStyle  = 2 ;


//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- name for indicator window

   string short_name=" ";
   IndicatorShortName(short_name);
   SetIndexBuffer(0, P1Buffer);
   SetIndexBuffer(1, P2Buffer);
 
//----

SetIndexArrow(0, 119); 
SetIndexArrow(1, 119); 


   SetIndexStyle(0, DRAW_ARROW, myStyle, 1);
   SetIndexStyle(1, DRAW_ARROW, myStyle, 1);   
  
   
   // setting the indicator values, which will be invisible on the chart
   SetIndexEmptyValue(0,0); 
   SetIndexEmptyValue(1,0);


   
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
   
   
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {

   int i, dayi, counted_bars = IndicatorCounted();
//---- check for possible errors
   if(counted_bars < 0) 
       return(-1);
//---- last counted bar will be recounted
   if(counted_bars > 0) 
       counted_bars--;  
   int limit = Bars - counted_bars;
//----   
   for(i = limit - 1; i >= 0; i--)
     {
        P1Buffer[i] = High[iHighest(NULL,0,MODE_HIGH,myPeriod,i)];
        P2Buffer[i] = Low[iLowest(NULL,0,MODE_LOW,myPeriod,i)];
     }    
 
   return(0);

  }