//+------------------------------------------------------------------+
//|       _TRO_Open                                                  |
//|                                                                  |
//|                                                                  |
//+------------------------------------------------------------------+

#property indicator_chart_window 

#property indicator_buffers 4

#property indicator_color1 LightGray 
#property indicator_color2 Gray
#property indicator_color3 DarkGray
#property indicator_color4 Silver  

// indicators parameters

//---- buffers
double P1Buffer[];
double P2Buffer[];
double P3Buffer[];
double P4Buffer[]; 

double xPrice ;
int myStyle  = 2 ;

int myWingDing  = 250 ;

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {

   SetIndexBuffer(0, P1Buffer);
   SetIndexBuffer(1, P2Buffer);
   SetIndexBuffer(2, P3Buffer);
   SetIndexBuffer(3, P4Buffer); 

SetIndexArrow(0, myWingDing); 
SetIndexArrow(1, myWingDing);
SetIndexArrow(2, myWingDing);
SetIndexArrow(3, myWingDing); 

SetIndexStyle(0, DRAW_ARROW, myStyle, 1);
SetIndexStyle(1, DRAW_ARROW, myStyle, 1);
SetIndexStyle(2, DRAW_ARROW, myStyle, 1);
SetIndexStyle(3, DRAW_ARROW, myStyle, 1);  
   
SetIndexEmptyValue(0,0); 
SetIndexEmptyValue(1,0);
SetIndexEmptyValue(2,0);
SetIndexEmptyValue(3,0);
   
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
   
   
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {

   int i, dayi, counted_bars = IndicatorCounted();
//---- check for possible errors
   if(counted_bars < 0) 
       return(-1);
//---- last counted bar will be recounted
   if(counted_bars > 0) 
       counted_bars--;  
   int limit = Bars - counted_bars;
//----   





   for(i = limit - 1; i >= 0; i--)
     {
      
        P1Buffer[i] =  iOpen(Symbol(), 0, i + 1) ;   
//        P1Buffer[i] =  iOpen(Symbol(), PERIOD_H1, i + 1) ;
//        P2Buffer[i] =  iOpen(Symbol(), PERIOD_D1, i + 1); 
//        P3Buffer[i] =  iOpen(Symbol(), PERIOD_W1, i + 1); 
//        P4Buffer[i] =  iOpen(Symbol(), PERIOD_MN1, i + 1); 
                    
     } // for 
 
   return(0);

  } // start