//+------------------------------------------------------------------+ 
//| __TRO_XY_Axis_Plot                                               | 
//|                                                                  | 
//|                                                                  | 
//|   Copyright  2008, Avery T. Horton, Jr. aka TheRumpledOne       |
//|                                                                  |
//|   PO BOX 43575, TUCSON, AZ 85733                                 |
//|                                                                  |
//|   GIFTS AND DONATIONS ACCEPTED                                   | 
//|                                                                  |
//|   therumpldone@gmail.com                                         |  
//+------------------------------------------------------------------+ 

#property  copyright "Copyright  2008, Avery T. Horton, Jr. aka TRO" 
#property  link      "http://www.therumpldone.com/" 
#property copyright "" 

#property link      "" 

#property indicator_chart_window 




//+------------------------------------------------------------------+ 
//| Custom indicator initialization function                         | 
//+------------------------------------------------------------------+ 
int init() 
  { 
  
     initGraph();
  
//---- 
   return(0); 
  } 
//+------------------------------------------------------------------+ 
//| Custom indicator deinitialization function                       | 
//+------------------------------------------------------------------+ 
int deinit() 
  { 
//---- 
    deleteObject();   
//---- 
   return(0); 
  } 
//+------------------------------------------------------------------+ 
//| Custom indicator iteration function                              | 
//+------------------------------------------------------------------+ 

int start() 
  {  
 
   objectBlank();   
  
   paintLine();
   
//---- 
   return(0); 
  } 
//+------------------------------------------------------------------+ 


void initGraph()
  {
   deleteObject();
   
//   objectCreate("line57a",10,1050,"-1050---------------------------------",10,"Arial",DimGray);
//   objectCreate("line57b",10,950,"-950----------------------------------",10,"Arial",DimGray);
   objectCreate("line57c",10,850,"-050----------------------------------",10,"Arial",DimGray);
   objectCreate("line57d",10,750,"-150----------------------------------",10,"Arial",DimGray);
   objectCreate("line57e",10,650,"-250----------------------------------",10,"Arial",DimGray);  
   objectCreate("line57f",10,550,"-350----------------------------------",10,"Arial",DimGray);
   objectCreate("line57g",10,450,"-450----------------------------------",10,"Arial",DimGray);
   objectCreate("line57h",10,350,"-550----------------------------------",10,"Arial",DimGray);
   objectCreate("line57i",10,250,"-650----------------------------------",10,"Arial",DimGray);
   objectCreate("line57" ,10,150,"-750----------------------------------",10,"Arial",DimGray);

   objectCreate("line97a",10,1000,"-1000------ xy axis plot  -----",10,"Arial",DimGray);
   objectCreate("line97b",10,900,"-900----------------------------------",10,"Arial",DimGray);
   objectCreate("line97c",10,800,"-100----------------------------------",10,"Arial",DimGray);
   objectCreate("line97d",10,700,"-200----------------------------------",10,"Arial",DimGray);
   objectCreate("line97e",10,600,"-300----------------------------------",10,"Arial",DimGray);  
   objectCreate("line97f",10,500,"-400----------------------------------",10,"Arial",DimGray);
   objectCreate("line97g",10,400,"-500----------------------------------",10,"Arial",DimGray);
   objectCreate("line97h",10,300,"-600----------------------------------",10,"Arial",DimGray);
   objectCreate("line97i",10,200,"-700----------------------------------",10,"Arial",DimGray);
   objectCreate("line97" ,10,100,"-800------- xy axis plot  -----",10,"Arial",DimGray);


   objectCreate("linex100",100,625,"|100",10,"Arial",DimGray);  
   objectCreate("linex200",200,625,"|200",10,"Arial",DimGray);  
   objectCreate("linex300",300,625,"|300",10,"Arial",DimGray);  
   objectCreate("linex400",400,625,"|400",10,"Arial",DimGray); 
   objectCreate("linex500",500,625,"|500",10,"Arial",DimGray);  
   objectCreate("linex600",600,625,"|600",10,"Arial",DimGray); 
   objectCreate("linex700",700,625,"|700",10,"Arial",DimGray);  
   objectCreate("linex800",800,625,"|800",10,"Arial",DimGray);  
   objectCreate("linex900",900,625,"|900",10,"Arial",DimGray);  
   objectCreate("linex1000",1000,625,"|1000",10,"Arial",DimGray);    
   objectCreate("linex1100",1100,625,"|1100",10,"Arial",DimGray);  
   objectCreate("linex1200",1200,625,"|1200",10,"Arial",DimGray);  
   objectCreate("linex1300",1300,625,"|1300",10,"Arial",DimGray);  
   objectCreate("linex1400",1400,625,"|1400",10,"Arial",DimGray);  
   
   
   objectCreate("linex100-",-100,625,"|-100",10,"Arial",DimGray);  
   objectCreate("linex200-",-200,625,"|-200",10,"Arial",DimGray);
   objectCreate("linex300-",-300,625,"|-300",10,"Arial",DimGray);  
   objectCreate("linex400-",-400,625,"|-400",10,"Arial",DimGray); 
   objectCreate("linex500-",-500,625,"|-500",10,"Arial",DimGray);  
   objectCreate("linex600-",-600,625,"|-600",10,"Arial",DimGray);   
   

  }   
  
//+------------------------------------------------------------------+
void objectCreate(string name,int x,int y,string text="-",int size=42,
                  string font="Arial",color colour=CLR_NONE)
  {
   ObjectCreate(name,OBJ_LABEL,0,0,0);
   ObjectSet(name,OBJPROP_CORNER,3);
   ObjectSet(name,OBJPROP_COLOR,colour);
   ObjectSet(name,OBJPROP_XDISTANCE,x);
   ObjectSet(name,OBJPROP_YDISTANCE,y);
   ObjectSetText(name,text,size,font,colour);
  }
  
void deleteObject()
  {  
  
  ObjectDelete("line57"); 
  ObjectDelete("line57a"); 
  ObjectDelete("line57b"); 
  ObjectDelete("line57c"); 
  ObjectDelete("line57d"); 
  ObjectDelete("line57e"); 
  ObjectDelete("line57f"); 
  ObjectDelete("line57g"); 
  ObjectDelete("line57h"); 
  ObjectDelete("line57i"); 
  
  ObjectDelete("line97"); 
  ObjectDelete("line97a"); 
  ObjectDelete("line97b"); 
  ObjectDelete("line97c"); 
  ObjectDelete("line97d"); 
  ObjectDelete("line97e"); 
  ObjectDelete("line97f"); 
  ObjectDelete("line97g"); 
  ObjectDelete("line97h"); 
  ObjectDelete("line97i"); 
  
   ObjectDelete("linex100");  
   ObjectDelete("linex200");  
   ObjectDelete("linex300");  
   ObjectDelete("linex400"); 
   ObjectDelete("linex500");  
   ObjectDelete("linex600"); 
   ObjectDelete("linex100-");  
   ObjectDelete("linex200-");
   ObjectDelete("linex300-");  
   ObjectDelete("linex400-"); 
   ObjectDelete("linex500-");  
   ObjectDelete("linex600-");   
   ObjectDelete("linex700");  
   ObjectDelete("linex800");  
   ObjectDelete("linex900");  
   ObjectDelete("linex1000");   
   ObjectDelete("linex1100");  
   ObjectDelete("linex1200");  
   ObjectDelete("linex1300");  
   ObjectDelete("linex1400"); 
   
  }
  
void objectBlank()
  {
        
   
   ObjectSet("line98",OBJPROP_COLOR,CLR_NONE);
   ObjectSet("line97",OBJPROP_COLOR,CLR_NONE); 
  }
 
  

  
void paintLine()
  {
   ObjectSet("line98",OBJPROP_COLOR,DimGray);
   ObjectSet("line97",OBJPROP_COLOR,DimGray);
   ObjectSet("line97a",OBJPROP_COLOR,DimGray);
   ObjectSet("line97b",OBJPROP_COLOR,DimGray);
   ObjectSet("line97c",OBJPROP_COLOR,DimGray);
   ObjectSet("line97d",OBJPROP_COLOR,DimGray);
   ObjectSet("line97e",OBJPROP_COLOR,DimGray);
   ObjectSet("line97f",OBJPROP_COLOR,DimGray);
   ObjectSet("line97g",OBJPROP_COLOR,DimGray);
   ObjectSet("line97h",OBJPROP_COLOR,DimGray);
   ObjectSet("line97i",OBJPROP_COLOR,DimGray);
   ObjectSet("line97",OBJPROP_COLOR,DimGray);   
   ObjectSet("line98",OBJPROP_COLOR,DimGray);
   
   ObjectSet("line57",OBJPROP_COLOR,DimGray);
   ObjectSet("line57a",OBJPROP_COLOR,DimGray);
   ObjectSet("line57b",OBJPROP_COLOR,DimGray);
   ObjectSet("line57c",OBJPROP_COLOR,DimGray);
   ObjectSet("line57d",OBJPROP_COLOR,DimGray);
   ObjectSet("line57e",OBJPROP_COLOR,DimGray);
   ObjectSet("line57f",OBJPROP_COLOR,DimGray);
   ObjectSet("line57g",OBJPROP_COLOR,DimGray);
   ObjectSet("line57h",OBJPROP_COLOR,DimGray);
   ObjectSet("line57i",OBJPROP_COLOR,DimGray);
   ObjectSet("line57",OBJPROP_COLOR,DimGray);  
  
  }